//Very Tiny Tic Tac Toe
//version 1
//By Sparr
//(c) 2004 Clarence Risher
//sparr0@gmail.com
//Released under the GNU GPL, latest version available at http://www.gnu.org/licenses/gpl.txt

//instructions
#define INSTRUCT
//play again option
#define AGAIN


#define NO_CALC_DETECT
#include <tigcclib.h>
#undef __need_in_use_bit
#define __need_in_use_bit ((void)0)
#include "extgraph.h"

short won;
register short x1 asm("d6");
register long board asm ("d5");
unsigned short sprites[3]={0,0b0110100110010110,0b1001011001101001};
long patterns[16]= \
{ \
//   POSITIONS
//   8 7 6 5 4 3 2 1 0
	0b111111111111010100,\
	0b111101111101111100,\
	0b011111110111111100,\
	0b111111111111010001,\
	0b110111110111110011,\
	0b111111111111101000,\
	0b111110111110111100,\
	0b101111111011111100,\
	0b111111111111100010,\
	0b111011111011110011,\
	0b000010000100100000,\
	0b111100110110001000,\
	0b111100110110100000,\
	0b111110110100100000,\
	0b001111111011111100,\
	0b110011111011110011};

void XORSprite(short x,short y,short sprite) {
	short sx,sy;
	for(sx=4;sx--;)
		for(sy=4;sy--;) {
			if(((sprite<<(sy*4))<<sx)&(1<<15)) {
				EXT_SETPIX(LCD_MEM,x+sx,y+sy);
			}
		}
}


void displayboard() {
	short p;
	for(p=9;p--;) {
		XORSprite((p%2)*7+2+71,(p/3)*7+8,0b0001000100010001);
		XORSprite((p%3)*7+71,(p%2)*7+2+8,0b0000000000001111);
		XORSprite((p%3)*7+71,(2-(p/3))*7+8,sprites[(board>>(p*2))&3]);
	}
}

void aimove() {
	short r,p,c,moved=0;
	++x1;
	for(c=0;c<16;c++) {
		for(r=0;r<4;r++) {
			if(!moved) {
				for(p=0;p<9;p++) {
					short bp=((board>>(p*2))&3);
					short pp=((patterns[c]>>(p*2))&3);
					if(!(
						pp==3
						||
						bp==pp
					)) {
						break;
					}
				}
				if(p==9) {
					moved=1;
					won=(c<5);
					board|=0b01<<(((0b1000011100011000>>c)&1)*2);
				}
			}
			board=
			((board&0b11000000000000)>>(6*2))|
			((board&0b11000000)>>(2*2))|
			((board&0b11)<<(2*2))|
			((board&0b1100000000000000)>>(4*2))|
			((board&0b1100000000)<<(0*2))|
			((board&0b1100)<<(4*2))|
			((board&0b110000000000000000)>>(2*2))|
			((board&0b110000000000)<<(2*2))|
			((board&0b110000L)<<(6*2));
		}
	}
	if (!moved) {
		if(!((board>>8)&3)) {
			board|=0b0100000000;
			return;
		}
		for(p=0;p<9;p++) {
			if(!((board>>(p*2))&3)) {
				board|=0b01<<(p*2);
				return;
			}
		}
	}
}

// Main Function
void _main(void)
{
	short registerbackup=board;
#ifdef AGAIN
	playagain:
#endif
	board=0;
	won=0;
	x1=0;
	ClrScr();
#ifdef INSTRUCT
	DrawStr(0, 0,"Use 0-9",A_NORMAL);
	DrawStr(0,10,"To Move",A_NORMAL);
#endif
	unsigned short key=0;
	displayboard();
	do {
		if(key=='0'&&board==0)
			aimove();
		if(key-'1'<9&&!((board>>((key-'1')*2))&3)) {
			board|=0b10L<<((key-'1')*2);
			++x1;
			aimove();
		}
		if(key==KEY_ESC)
			goto quit;
		displayboard();
		if(won||x1>8) break;
	} while((key=ngetchx()));
#ifdef AGAIN
	if(DlgMessage(won?"You Lose":"Tie","Again?",BT_YES,BT_NO)==KEY_ENTER)
		goto playagain;
#else
	DrawStr(0,20,won?"You Lose":"Tie",A_NORMAL);
	ngetchx();
#endif
	quit:
	board=registerbackup;
}